#ifndef __XAUDIOWAVE_H__
#define __XAUDIOWAVE_H__

#include "XAudio.h"
#include <vector>
#include <algorithm>

class WaveCallback;

class XAudioWave{

private:
typedef void (*PFUNC)();
typedef void (*PFUNC_VOIDP)( void * );
typedef void (*PFUNC_VOIDP_HRESULT)( void *, HRESULT );

public:
enum STATUS{
	STATUS_WAITING,
	STATUS_PLAYING,
	STATUS_STOP,
};

public:
	XAudioWave();
	~XAudioWave();

	bool Load( const char *pFileName );
	bool Release();

	bool Play( int NumLoops = 0 );
	bool Stop();

private:
	IXAudio2SourceVoice* pSourceVoice;

	int WaveSize;
	BYTE *pData;
};

#endif //__XAUDIOWAVE_H__

